% Copyright (C) Consortium Scilab DIGITEO - Michael Baudin - 2011

\documentclass[xcolor=dvipsnames]{beamer}

\include{beamer_scilab}
\include{macros}

% To produce the handout
%\usepackage{pgfpages}
%\pgfpagesuselayout{2 on 1}[a4paper,border shrink=5mm]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\title{
Commented Demonstrations of Scilab, 
The free platform for Numerical Computation
}
\author{\textcolor{green!50!black}{Micha\"el~Baudin}\inst{1}}

\institute{
  \inst{1}
  Digitéo\\
  Rocquencourt\\
  michael.baudin@scilab.org
}

\date{July 2011}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{document}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  \begin{frame}
  \titlepage
  \end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{}

\begin{center}
\includegraphics[width=\textwidth]{Scilab}
\end{center}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% \begin{frame}
% \frametitle{Outline}
% \tableofcontents
% \end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Licence and Project}

\begin{itemize}
\item This file must be used under the terms of the Creative Commons Attribution-ShareAlike 3.0 Unported License:

\begin{center}
\url{http://creativecommons.org/licenses/by-sa/3.0}
\end{center}

\item This demonstration is based on the open source collection of demonstrations available at:

\begin{center}
\url{http://forge.scilab.org/index.php/p/scidemo/}
\end{center}

\end{itemize}

\begin{center}
 Copyright \copyright 2010-2011 - DIGITEO - Michael Baudin
\end{center}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Introduction}

Goal of this presentation
\begin{itemize}
\item   An overview of some classical numerical methods available in Scilab
\item   A simple demo for selected functions
\end{itemize}

Contents
\begin{itemize}
\item   Complex Elementary Functions : the acosh function
\item   Dense Linear Algebra : the spec function
\item   Optimization : the optim function
\item   Differential Equations : the ode function
\item   Probabilities/Statistics : the grand function
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Complex Elementary Functions}


Elementary Functions
\begin{itemize}
\item More that 60 elementary functions: cos, sin, exp, log, ...
\item Degree-based (sind, cosd, …) for accuracy (Matlab compatibility)
\item Special functions : gamma, beta, erf, etc...
\item Open Source Libraries : SLATEC (e.g. bessel*), SPECFUN (e.g. calerf).
\item Discrete maths: factorial, gamma, gammaln, binomial, ...
\end{itemize}

Mathematics
\begin{itemize}
\item  Elementary functions are extended to complex arguments.
\item  A branch cut is a line of discontinuity of an inverse function.
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Complex Elementary Functions}


Elementary Functions
\begin{itemize}
\item Example : the branch cut for acosh are $z\leq -1$ and $z\geq 1$ 
\item Demonstration : Demos / scidemo / complex\_functions / acosh
\item Authors : Pincon 2001, Mar\'echal 2008, Baudin 2010
\end{itemize}

\begin{center}
\includegraphics[width=0.6\textwidth]{demo_complexfunctions_acosh}
\end{center}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Dense Linear Algebra}


 Dense Linear Algebra
\begin{itemize}
\item Matrix algebra: +, -, *, ./ , $\hat{\,}$, etc…
\item Matrix functions : expm, pow, logm, cosm, etc...
\item More than 50 dense high level linear algebra functions: backslash, lu, spec, svd, chol, lsq, etc…
\item Open Source Libraries : BLAS, LAPACK 
\end{itemize}

 Mathematics
\begin{itemize}
\item The right eigenvector x and eigenvalue s of a matrix 2-by-2 real matrix 
      A are satisfying the equation : Ax=sx.
\item If x is along the unit circle, Ax is allong an ellipse.
\item If the matrix A is symmetric, the major and minor axes of the ellipse are 
      the two eigenvectors and the eigenvalues are real.
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Dense Linear Algebra}

Dense Linear Algebra
\begin{itemize}
\item Example : the spec function computes the eigenvalues/eigenvectors
\item  Demonstration : Demos / scidemo / eigenvalue\_show
\item  Authors : DIGITEO - Michael Baudin - 2010
\end{itemize}

\begin{center}
\includegraphics[width=0.5\textwidth]{demo_eigenvalueshow}
\end{center}

\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Optimization}

 Optimization
\begin{itemize}
\item Nonlinear unconstrained (or bounds) optimization : optim
\item Nonlinear least squares: leastsq, lsqrsolve
\item Derivative-free nonlinear optimization: fminsearch
\item Linear, quadratic optimization: qld, karmarkar, qpsolve
\item Global optimisation: optim\_ga, optim\_sa
\item Open Source Libraries : qld, Modulopt 
\end{itemize}

 Mathematics
\begin{itemize}
\item The Rosenbrock problem: $\textrm{min. } 100(x_2-x_1^2)^2 + (1-x_1)^2$
\item The starting point is: $x =(-1.2,1)^T$
\item The global minimum is: $x =(1,1)^T$
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Optimization}

Optimization
\begin{itemize}
\item Example : the \scivar{optim} function 
\item Demonstration : Demos / scidemo / rosenbrock\_show
\item Authors : DIGITEO - Michael Baudin - 2010
\end{itemize}

\begin{center}
\includegraphics[width=0.7\textwidth]{demo_rosenbrockplot.pdf}
\end{center}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Differential Equations}

 Differential Equations
\begin{itemize}
\item  9 solvers for ODEs and integration : ode, bvode, dassl, etc... 
\item Can manage Right Hand Sides as macros or compiled functions.
\item Includes a collection of algorithms, for example :
\item Stiff problems : Backward Differentiation Formula (BDF)
\item Non-stiff problems : Adams method
\item Open Source Libraries : Odepack
\end{itemize}

Mathematics
\begin{itemize}
\item Consider the linear equation: $\frac{dy}{dt} = Ay(t)$
\item with initial state $y(0)=y_0$
\item The solution is $y(t)=y_0 e^{At}$
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Differential Equations}

 Differential Equations
\begin{itemize}
\item Example : ode (approximate solution), expm (exact solution)
\item Demonstration : Demos / scidemo / edolinear\_show
\item Authors : DIGITEO – Michael Baudin - 2010
\end{itemize}

\begin{center}
\includegraphics[width=0.6\textwidth]{demo_linearodeplot}
\end{center}

\end{frame}
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Probabilities/Statistics}

Probabilities/Statistics
\begin{itemize}
\item Most common tools: mean, variance, pca, etc…
\item 11 Cumulated Density Functions: cdfnor, cdfpoi, etc…
\item 6 Uniform Random Number Generators e.g. grand(“mt”) is Mersenne-Twister
\item 16 Non-Uniform RNGs: e.g. grand(“nor”), grand(“chi”), etc…
\item Open Source Libraries : Dcdflib
\item ATOMS/lowdisc: Low Discrepancy Sequences: Halton, Sobol, etc…
\end{itemize}

Mathematics 
\begin{itemize}
\item Consider the normal distribution: $f(x)=\frac{1}{\sigma \sqrt{2\pi} } exp \left( - \frac{ (x-\mu)^2 }{2\sigma^2} \right)$
\end{itemize}

\end{frame}



 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{Probabilities/Statistics}

Probabilities/Statistics
\begin{itemize}
\item  Example : \scivar{grand}, \scivar{histplot}, \scivar{intg} (quadrature)
\item Demonstration : Demos / scidemo / normdist\_show
\item Authors : DIGITEO - Michael Baudin - 2010
\end{itemize}

\begin{center}
\includegraphics[width=0.6\textwidth]{demo_normdist}
\end{center}

\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}
\frametitle{References}

\begin{itemize}
\item Main Portal: \url{http://www.scilab.org}
\item Tutorials: 
\begin{small}
\begin{center}
\url{http://www.scilab.org/support/documentation/tutorials}
\end{center}
\end{small}
\item « Introduction to Scilab », Consortium Scilab – DIGITEO, Michael Baudin, 2010
\item « Introduction to probabilities with Scilab », Consortium Scilab – DIGITEO, Michael Baudin, 2010
\item « Optimization with Scilab », Consortium Scilab – DIGITEO - INRIA, Michael Baudin, Vincent Couvert, Serge Steer, 2010
\item Low Discrepancy Sequences : 
\begin{center}
\url{http://atoms.scilab.org/toolboxes/lowdisc}
\end{center}
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%               *    THE END    *
%%

\begin{frame}
\frametitle{Thanks for your attention}

\begin{center}
\includegraphics[width=0.7\textwidth]{Background}

\includegraphics[width=0.1\textwidth]{Puffin} \hspace{1cm} www.scilab.org
\end{center}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


  \end{document}


